#!/bin/bash

mkdir -p ~/tmp

if test "$1" != "" ; then
	sapidir="$1"
	if ! echo $sapidir | grep "^/" >/dev/null 2>/dev/null ; then
		if ! echo $sapidir | grep '^\.' >/dev/null ; then
			sapidir=".$sapidir"
		fi
		sapidir="$HOME/$sapidir"
	fi
elif test "$WINEPREFIX" != "" ; then
	sapidir="$WINEPREFIX"
else
	sapidir=~/.wine
fi

export WINEPREFIX="$sapidir"

set_winver() {
    echo "Setting Windows version to $1"
    cat > ~/tmp/set-winver.reg <<_EOF_
REGEDIT4

[HKEY_CURRENT_USER\Software\Wine]
"Version"="$1"
                  
_EOF_
    wine regedit ~/tmp/set-winver.reg
}

unset_winver() {
    echo "Clearing Windows version back to default"
    cat > ~/tmp/unset-winver.reg <<_EOF_
REGEDIT4

[HKEY_CURRENT_USER\Software\Wine]
"Version"=-

_EOF_
    wine regedit ~/tmp/unset-winver.reg
}

while true ; do
	echo
	echo -n "Instalujesz SAPI5.1 w $sapidir? [T/n]: "
	read a
	if test "$a" = "T" || test "$a" = "t" || test "$a" = "" ; then
		break
	elif test "$a" = "n" || test "$a" = "N" ; then
		exit 0
	fi
done

set_winver win2k
wine msiexec /i `pwd`/data/sapi.msi
unset_winver
#cp -f open-sapi/msvcp60.dll "$sapidir"/drive_c/windows/system32/
echo SAPI5.1 zainstalowano
