#!c:/Python27/python.exe
#coding: utf-8


# ssapi.py - SAPI 5.1 server for Wine
# Copyright (C) Bohdan R. Rau 2012 <ethanak@polip.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this program.  If not, write to:
# 	The Free Software Foundation, Inc.,
# 	51 Franklin Street, Fifth Floor
# 	Boston, MA  02110-1301, USA.


_VERSION = "0.1.3"

#from win32com.client import constants
# win32com.client.constants seems to be broken?
# so we simply create own constants class instead!

class constants:
	SSFMCreate                    =0x2		# from enum SpeechStreamFileMode
	SSFMCreateForWrite            =0x3		# from enum SpeechStreamFileMode
	SSFMOpenForRead               =0x0		# from enum SpeechStreamFileMode
	SSFMOpenReadWrite             =0x1		# from enum SpeechStreamFileMode
	SSSPTRelativeToCurrentPosition=0x1		# from enum SpeechStreamSeekPositionType
	SSSPTRelativeToEnd            =0x2		# from enum SpeechStreamSeekPositionType
	SSSPTRelativeToStart          =0x0		# from enum SpeechStreamSeekPositionType

import win32com.client,os,SocketServer,sys,re
import struct,pythoncom,getopt,threading,traceback,tempfile

SocketServer.ThreadingTCPServer.allow_reuse_address=True


import xml.parsers.expat


_hent={
    "nbsp":160,"iexcl":161,"cent":162,"pound":163,"curren":164,"yen":165,"brvbar":166,"brkbar":166,"sect":167,"uml":168,"die":168,"Dot":168,"copy":169,"ordf":170,"laquo":171,"not":172,"shy":173,"reg":174,"hibar":175,"macr":175,
    "deg":176,"plusmn":177,"sup2":178,"sup3":179,"acute":180,"micro":181,"para":182,"middot":183,"cedil":184,"sup1":185,"ordm":186,"raquo":187,"frac14":188,"frac12":189,"half":189,"frac34":190,"iquest":191,"Agrave":192,"Aacute":193,"Acirc":194,
    "Atilde":195,"Auml":196,"Aring":197,"AElig":198,"Ccedil":199,"Egrave":200,"Eacute":201,"Ecirc":202,"Euml":203,"Igrave":204,"Iacute":205,"Icirc":206,"Iuml":207,"ETH":208,"Ntilde":209,"Ograve":210,"Oacute":211,"Ocirc":212,"Otilde":213,"Ouml":214,
    "times":215,"Oslash":216,"Ugrave":217,"Uacute":218,"Ucirc":219,"Uuml":220,"Yacute":221,"THORN":222,"szlig":223,"agrave":224,"aacute":225,"acirc":226,"atilde":227,"auml":228,"aring":229,"aelig":230,"ccedil":231,"egrave":232,"eacute":233,"ecirc":234,
    "euml":235,"igrave":236,"iacute":237,"icirc":238,"iuml":239,"eth":240,"ntilde":241,"ograve":242,"oacute":243,"ocirc":244,"otilde":245,"ouml":246,"divide":247,"oslash":248,"ugrave":249,"uacute":250,"ucirc":251,"uuml":252,"yacute":253,"thorn":254,
    "yuml":255,"Amacr":256,"amacr":257,"Abreve":258,"abreve":259,"Aogon":260,"aogon":261,"Cacute":262,"cacute":263,"Ccirc":264,"ccirc":265,"Cdot":266,"cdot":267,"Ccaron":268,"ccaron":269,"Dcaron":270,"dcaron":271,"Dstrok":272,"dstrok":273,"Emacr":274,
    "emacr":275,"Edot":278,"edot":279,"Eogon":280,"eogon":281,"Ecaron":282,"ecaron":283,"Gcirc":284,"gcirc":285,"Gbreve":286,"gbreve":287,"Gdot":288,"gdot":289,"Gcedil":290,"gcedil":291,"Hcirc":292,"hcirc":293,"Hstrok":294,"hstrok":295,"Itilde":296,
    "itilde":297,"Imacr":298,"imacr":299,"Iogon":302,"iogon":303,"Idot":304,"inodot":305,"IJlig":306,"ijlig":307,"Jcirc":308,"jcirc":309,"Kcedil":310,"kcedil":311,"kgreen":312,"Lacute":313,"lacute":314,"Lcedil":315,"lcedil":316,"Lcaron":317,"lcaron":318,
    "Lmidot":319,"lmidot":320,"Lstrok":321,"lstrok":322,"Nacute":323,"nacute":324,"Ncedil":325,"ncedil":326,"Ncaron":327,"ncaron":328,"napos":329,"ENG":330,"eng":331,"Omacr":332,"omacr":333,"Odblac":336,"odblac":337,"OElig":338,"oelig":339,"Racute":340,
    "racute":341,"Rcedil":342,"rcedil":343,"Rcaron":344,"rcaron":345,"Sacute":346,"sacute":347,"Scirc":348,"scirc":349,"Scedil":350,"scedil":351,"Scaron":352,"scaron":353,"Tcedil":354,"tcedil":355,"Tcaron":356,"tcaron":357,"Tstrok":358,"tstrok":359,"Utilde":360,
    "utilde":361,"Umacr":362,"umacr":363,"Ubreve":364,"ubreve":365,"Uring":366,"uring":367,"Udblac":368,"udblac":369,"Uogon":370,"uogon":371,"Wcirc":372,"wcirc":373,"Ycirc":374,"ycirc":375,"Yuml":376,"Zacute":377,"zacute":378,"Zdot":379,"zdot":380,
    "Zcaron":381,"zcaron":382,"fnof":402,"gacute":501,"apos":700,"circ":710,"caron":711,"breve":728,"dot":729,"ring":730,"ogon":731,"tilde":732,"dblac":733,"Aacgr":902,"Eacgr":904,"EEacgr":905,"Iacgr":906,"Oacgr":908,"Uacgr":910,"OHacgr":911,
    "idiagr":912,"Alpha":913,"Agr":913,"Beta":914,"Bgr":914,"Gamma":915,"Ggr":915,"Delta":916,"Dgr":916,"Epsilon":917,"Egr":917,"Zeta":918,"Zgr":918,"Eta":919,"EEgr":919,"Theta":920,"THgr":920,"Iota":921,"Igr":921,"Kappa":922,
    "Kgr":922,"Lambda":923,"Lgr":923,"Mu":924,"Mgr":924,"Nu":925,"Ngr":925,"Xi":926,"Xgr":926,"Omicron":927,"Ogr":927,"Pi":928,"Pgr":928,"Rho":929,"Rgr":929,"Sigma":931,"Sgr":931,"Tau":932,"Tgr":932,"Upsi":933,
    "Ugr":933,"Upsilon":933,"Phi":934,"PHgr":934,"Chi":935,"KHgr":935,"Psi":936,"PSgr":936,"Omega":937,"OHgr":937,"Idigr":938,"Udigr":939,"aacgr":940,"eacgr":941,"eeacgr":942,"iacgr":943,"udiagr":944,"alpha":945,"agr":945,"beta":946,
    "bgr":946,"gamma":947,"ggr":947,"delta":948,"dgr":948,"epsi":949,"egr":949,"epsilon":949,"zeta":950,"zgr":950,"eta":951,"eegr":951,"thetas":952,"thgr":952,"theta":952,"iota":953,"igr":953,"kappa":954,"kgr":954,"lambda":955,
    "lgr":955,"mu":956,"mgr":956,"nu":957,"ngr":957,"xi":958,"xgr":958,"omicron":959,"ogr":959,"pi":960,"pgr":960,"rho":961,"rgr":961,"sigmav":962,"sfgr":962,"sigmaf":962,"sigma":963,"sgr":963,"tau":964,"tgr":964,
    "upsi":965,"ugr":965,"upsilon":965,"phis":966,"phgr":966,"phi":966,"chi":967,"khgr":967,"psi":968,"psgr":968,"omega":969,"ohgr":969,"idigr":970,"udigr":971,"oacgr":972,"uacgr":973,"ohacgr":974,"thetav":977,"thetasym":977,"upsih":978,
    "phiv":981,"piv":982,"gammad":988,"kappav":1008,"rhov":1009,"IOcy":1025,"DJcy":1026,"GJcy":1027,"Jukcy":1028,"DScy":1029,"Iukcy":1030,"YIcy":1031,"Jsercy":1032,"LJcy":1033,"NJcy":1034,"TSHcy":1035,"KJcy":1036,"Ubrcy":1038,"DZcy":1039,"Acy":1040,
    "Bcy":1041,"Vcy":1042,"Gcy":1043,"Dcy":1044,"IEcy":1045,"ZHcy":1046,"Zcy":1047,"Icy":1048,"Jcy":1049,"Kcy":1050,"Lcy":1051,"Mcy":1052,"Ncy":1053,"Ocy":1054,"Pcy":1055,"Rcy":1056,"Scy":1057,"Tcy":1058,"Ucy":1059,"Fcy":1060,
    "KHcy":1061,"TScy":1062,"CHcy":1063,"SHcy":1064,"SHCHcy":1065,"HARDcy":1066,"Ycy":1067,"SOFTcy":1068,"Ecy":1069,"YUcy":1070,"YAcy":1071,"acy":1072,"bcy":1073,"vcy":1074,"gcy":1075,"dcy":1076,"iecy":1077,"zhcy":1078,"zcy":1079,"icy":1080,
    "jcy":1081,"kcy":1082,"lcy":1083,"mcy":1084,"ncy":1085,"ocy":1086,"pcy":1087,"rcy":1088,"scy":1089,"tcy":1090,"ucy":1091,"fcy":1092,"khcy":1093,"tscy":1094,"chcy":1095,"shcy":1096,"shchcy":1097,"hardcy":1098,"ycy":1099,"softcy":1100,
    "ecy":1101,"yucy":1102,"yacy":1103,"iocy":1105,"djcy":1106,"gjcy":1107,"jukcy":1108,"dscy":1109,"iukcy":1110,"yicy":1111,"jsercy":1112,"ljcy":1113,"njcy":1114,"tshcy":1115,"kjcy":1116,"ubrcy":1118,"dzcy":1119,"ensp":8194,"emsp":8195,"emsp13":8196,
    "emsp14":8197,"numsp":8199,"puncsp":8200,"thinsp":8201,"hairsp":8202,"zwnj":8204,"zwj":8205,"lrm":8206,"rlm":8207,"dash":8208,"ndash":8211,"endash":8211,"mdash":8212,"emdash":8212,"horbar":8213,"Verbar":8214,"lsquo":8216,"rsquor":8216,"rsquo":8217,"sbquo":8218,
    "lsquor":8218,"ldquo":8220,"rdquor":8220,"rdquo":8221,"bdquo":8222,"ldquor":8222,"dagger":8224,"Dagger":8225,"bull":8226,"nldr":8229,"hellip":8230,"mldr":8230,"permil":8240,"prime":8242,"vprime":8242,"Prime":8243,"tprime":8244,"bprime":8245,"lsaquo":8249,"rsaquo":8250,
    "oline":8254,"caret":8257,"hybull":8259,"frasl":8260,"euro":8364,"tdot":8411,"DotDot":8412,"incare":8453,"hamilt":8459,"planck":8463,"image":8465,"lagran":8466,"ell":8467,"numero":8470,"copysr":8471,"weierp":8472,"real":8476,"rx":8478,"trade":8482,"ohm":8486,
    "angst":8491,"bernou":8492,"phmmat":8499,"order":8500,"alefsym":8501,"aleph":8501,"beth":8502,"gimel":8503,"daleth":8504,"frac13":8531,"frac23":8532,"frac15":8533,"frac25":8534,"frac35":8535,"frac45":8536,"frac16":8537,"frac56":8538,"frac18":8539,"frac38":8540,"frac58":8541,
    "frac78":8542,"larr":8592,"uarr":8593,"rarr":8594,"darr":8595,"harr":8596,"xhArr":8596,"xharr":8596,"varr":8597,"nwarr":8598,"nearr":8599,"drarr":8600,"dlarr":8601,"nlarr":8602,"nrarr":8603,"rarrw":8605,"Larr":8606,"Rarr":8608,"larrtl":8610,"rarrtl":8611,
    "map":8614,"larrhk":8617,"rarrhk":8618,"larrlp":8619,"rarrlp":8620,"harrw":8621,"nharr":8622,"lsh":8624,"rsh":8625,"crarr":8629,"cularr":8630,"curarr":8631,"olarr":8634,"orarr":8635,"lharu":8636,"lhard":8637,"uharr":8638,"uharl":8639,"rharu":8640,"rhard":8641,
    "dharr":8642,"dharl":8643,"rlarr2":8644,"lrarr2":8646,"larr2":8647,"uarr2":8648,"rarr2":8649,"darr2":8650,"lrhar2":8651,"rlhar2":8652,"nlArr":8653,"nhArr":8654,"nrArr":8655,"lArr":8656,"xlArr":8656,"uArr":8657,"rArr":8658,"xrArr":8658,"dArr":8659,"hArr":8660,
    "iff":8660,"vArr":8661,"lAarr":8666,"rAarr":8667,"forall":8704,"comp":8705,"part":8706,"exist":8707,"nexist":8708,"empty":8709,"nabla":8711,"isin":8712,"notin":8713,"epsis":8714,"ni":8715,"bepsi":8717,"prod":8719,"coprod":8720,"amalg":8720,"samalg":8720,
    "sum":8721,"minus":8722,"mnplus":8723,"plusdo":8724,"setmn":8726,"ssetmn":8726,"lowast":8727,"compfn":8728,"radic":8730,"prop":8733,"vprop":8733,"infin":8734,"ang90":8735,"ang":8736,"angmsd":8737,"angsph":8738,"mid":8739,"nmid":8740,"par":8741,"spar":8741,
    "npar":8742,"nspar":8742,"and":8743,"or":8744,"cap":8745,"cup":8746,"int":8747,"conint":8750,"there4":8756,"becaus":8757,"sim":8764,"thksim":8764,"bsim":8765,"wreath":8768,"nsim":8769,"sime":8771,"nsime":8772,"cong":8773,"ncong":8775,"asymp":8776,
    "ap":8776,"thkap":8776,"nap":8777,"ape":8778,"bcong":8780,"bump":8782,"bumpe":8783,"esdot":8784,"eDot":8785,"efDot":8786,"erDot":8787,"colone":8788,"ecolon":8789,"ecir":8790,"cire":8791,"wedgeq":8793,"trie":8796,"ne":8800,"equiv":8801,"nequiv":8802,
    "le":8804,"les":8804,"ge":8805,"ges":8805,"lE":8806,"gE":8807,"lnE":8808,"lne":8808,"lvnE":8808,"gnE":8809,"gne":8809,"gvnE":8809,"Lt":8810,"Gt":8811,"twixt":8812,"nlt":8814,"ngt":8815,"nle":8816,"nles":8816,"nge":8817,
    "nges":8817,"lsim":8818,"gsim":8819,"lg":8822,"gl":8823,"pr":8826,"sc":8827,"pre":8828,"cupre":8828,"sce":8829,"sccue":8829,"prsim":8830,"scsim":8831,"npr":8832,"nsc":8833,"sub":8834,"sup":8835,"nsub":8836,"nsup":8837,"sube":8838,
    "subE":8838,"supe":8839,"supE":8839,"nsube":8840,"nsubE":8840,"nsupe":8841,"nsupE":8841,"subne":8842,"subnE":8842,"vsubne":8842,"vsubnE":8842,"supne":8843,"supnE":8843,"vsupne":8843,"vsupnE":8843,"uplus":8846,"sqsub":8847,"sqsup":8848,"sqsube":8849,"sqsupe":8850,
    "sqcap":8851,"sqcup":8852,"oplus":8853,"ominus":8854,"otimes":8855,"osol":8856,"odot":8857,"ocir":8858,"oast":8859,"odash":8861,"plusb":8862,"minusb":8863,"timesb":8864,"sdotb":8865,"vdash":8866,"dashv":8867,"top":8868,"perp":8869,"bottom":8869,"models":8871,
    "vDash":8872,"Vdash":8873,"Vvdash":8874,"nvdash":8876,"nvDash":8877,"nVdash":8878,"nVDash":8879,"vltri":8882,"vrtri":8883,"ltrie":8884,"rtrie":8885,"mumap":8888,"intcal":8890,"veebar":8891,"barwed":8892,"diam":8900,"sdot":8901,"sstarf":8902,"divonx":8903,"bowtie":8904,
    "ltimes":8905,"rtimes":8906,"lthree":8907,"rthree":8908,"bsime":8909,"cuvee":8910,"cuwed":8911,"Sub":8912,"Sup":8913,"Cap":8914,"Cup":8915,"fork":8916,"ldot":8918,"gsdot":8919,"Ll":8920,"Gg":8921,"leg":8922,"gel":8923,"els":8924,"egs":8925,
    "cuepr":8926,"cuesc":8927,"npre":8928,"nsce":8929,"lnsim":8934,"gnsim":8935,"prnsim":8936,"scnsim":8937,"nltri":8938,"nrtri":8939,"nltrie":8940,"nrtrie":8941,"vellip":8942,"Barwed":8966,"lceil":8968,"rceil":8969,"lfloor":8970,"rfloor":8971,"drcrop":8972,"dlcrop":8973,
    "urcrop":8974,"ulcrop":8975,"telrec":8981,"target":8982,"ulcorn":8988,"urcorn":8989,"dlcorn":8990,"drcorn":8991,"frown":8994,"sfrown":8994,"smile":8995,"ssmile":8995,"lang":9001,"rang":9002,"blank":9251,"oS":9416,"uhblk":9600,"lhblk":9604,"block":9608,"blk14":9617,
    "blk12":9618,"blk34":9619,"squ":9633,"square":9633,"squf":9642,"rect":9645,"marker":9646,"xutri":9651,"utrif":9652,"utri":9653,"rtrif":9656,"rtri":9657,"xdtri":9661,"dtrif":9662,"dtri":9663,"ltrif":9666,"ltri":9667,"loz":9674,"cir":9675,"xcirc":9675,
    "starf":9733,"star":9734,"phone":9742,"female":9792,"male":9794,"spades":9824,"clubs":9827,"hearts":9829,"diams":9830,"sung":9834,"flat":9837,"natur":9838,"sharp":9839,"check":10003,"cross":10007,"malt":10016,"lozf":10022,"loz":10023,"sext":10038,"fflig":64256,
    "filig":64257,"fllig":64258,"ffilig":64259,"ffllig":64260};

_rx=re.compile('&([^;]{1,6});',re.DOTALL)
_rdec=re.compile('^#([0-9]+)$')
_rhex=re.compile('^#x([0-9a-f]+)$',re.I)

def _r2s(text):
    
    def _df(a):
        a=a.group(1)
        global _rdec,_rhex,_hent
        n=_hent.get(a,0)
        if n == 0:
            r=_rhex.match(a)
            if r:
                n=int(r.group(1),16)
            else:
                r=_rdec.match(a)
                if r:
                    n=int(r.group(1),10)
        if n == 0:
            return '&%s;' % a
        return '&#x%X;' % n
    
    return _rx.sub(_df,text)




class SapiHandler(SocketServer.StreamRequestHandler):
	sps=["Name","Gender","Language","Vendor","Age"]
	_i1v=(0x406,0x407,0x409,0x40a,0x40f,0x40c,0x410,0x413,0x416,0x41d,0x436,
		0x452,0x807,0x809,0x80a,0x810,0x813,0x816,0x81d,0xc09,0xc0c)
	_i2v=(0x405,0x415,0x418)

	
	@staticmethod
	def ensure(nr,mini,maxi):
		nr=int(nr)
		if nr < mini:
			return mini
		if nr > maxi:
			return maxi
		return nr
	
	def encoding(self,voice):
		if voice is None:
			return None
		pythoncom.CoInitialize()
		v=self.server.voices[voice]
		lang=int(v.GetAttribute('Language'),16)
		if lang in self._i1v:
			return 'ISO-8859-1'
		elif lang in self._i2v:
			return 'ISO-8859-2'
		return None
		
	def validate_data(self,otext,voice):
		global _rv
		text=otext.strip()
		if text == '':
			return 'Input error:Empty input'
		if not text.startswith('<'):
			try:
				text=otext.decode('utf-8')
			except:
				enc=self.encoding(voice)
				if enc:
					try:
						return None,text.decode(enc)
					except:
						pass
				return 'Input error:Encoding not UTF-8'
			return None,text
		parser = xml.parsers.expat.ParserCreate()
		text=_r2s(otext)
		try:
			trans=False
			try:
				text=otext.decode('utf-8')
				trans=True
			except:
				enc=self.encoding(voice)
				if enc:
					try:
						text=otext.decode(enc)
						trans=True
					except:
						pass
			if not trans:
				return 'Input error:Encoding not UTF-8'
			parser.Parse(text.encode('utf-8'),True)
			return None,text
		except UnicodeDecodeError:
			return 'Input error:Encoding not UTF-8'
		except xml.parsers.expat.ExpatError,e:
			return 'XML error:'+xml.parsers.expat.ErrorString(e.code),otext
		except:
			return 'Input validator:'+ traceback.format_exc().replace('\r','').replace('\n','\\n'),otext
		
	
	def __init__(self,*args):
		SocketServer.StreamRequestHandler.__init__(self,*args)
		
	def voices(self):
		pythoncom.CoInitialize()
		v=self.server.voices
		rlist=[]
		for n in range(len(v)):
			try:
				row=[str(v[n].GetAttribute(s)) for s in self.sps]
				rlist.append("297:VoiceList:%d:%s" % (n,':'.join(row)))
			except:
				pass
		rlist.append('293:EndOfList:')
		self.request.sendall('\n'.join(rlist)+'\n')
		pythoncom.CoUninitialize()

	def prepareVoiceByName(self,name):
		pythoncom.CoInitialize()
		v=self.server.voices
		rc=-1
		for n in range(len(v)):
			if str(v[n].getAttribute("Name")) == name:
				rc=n
				break
		pythoncom.CoUninitialize()
		if rc >= 0:
			self.request.sendall('202:Setting OK:setVoice\n')
			return rc
		else:
			self.request.sendall('508:Bad voice name:%s\n' % name)
		return None
		
	def prepareVoice(self,nrs):
		try:
			nr=int(nrs)
			if nr >= 0 and nr < len(self.server.voices):
				self.request.sendall('202:Setting OK:setVoice\n')
				return nr
		except:
			self.request.sendall('508:Bad voice number:%s\n' % nrs)
			return None
		
	def speak(self,data,settings):
		err,data=self.validate_data(data,settings.get('voice',None))
		if err:
			self.request.sendall("500:%s\n" % err);
			return
		pythoncom.CoInitialize()
		self.server.mutex.acquire()
		try:
			if 'volume' in settings:
				self.server.speaker.Volume=settings['volume']
			if 'rate' in settings:
				self.server.speaker.Rate=settings['rate']
			if 'voice' in settings:
				try:
					self.server.speaker.Voice=self.server.voices[settings['voice']]
				except:
					sys.stderr.write("Cannot set voice!\n")
			if self.server.filemode:
				stream=win32com.client.Dispatch("SAPI.SpFileStream")
				stream.Open(self.server.tempFile,constants.SSFMCreateForWrite)
			else:
				stream=win32com.client.Dispatch("SAPI.SpMemoryStream")
			self.server.speaker.AudioOutputStream=stream
			self.server.speaker.speak(data)
			if self.server.filemode:
				stream.Close()
				data=open(self.server.tempFile,'rb').read()
				datasize=len(data)
			else:
				datasize=int(stream.Seek(0, constants.SSSPTRelativeToEnd))
				stream.Seek(0, constants.SSSPTRelativeToStart)
				data=str(stream.Read(None,datasize)[1])
				wfx=stream.Format.GetWaveFormatEx()
		except:
			self.server.mutex.release()
			err=traceback.format_exc().replace('\r','').replace('\n','\\n')
			self.request.sendall('500:Internal error: %s\n' % (err,))
			print traceback.format_exc()
			pythoncom.CoUninitialize()
			return
			
		self.server.mutex.release()
		
		if self.server.filemode:
			self.request.sendall('200:OK Wave data follows:%d\n' % datasize)
		else:
			# we must costruct wav header manually
			
			hdr=struct.pack('<4sl4s4slhhllhh4sl', 'RIFF', 36 + datasize,
				'WAVE', 'fmt ', 16,
				wfx.FormatTag, wfx.Channels, wfx.SamplesPerSec,
				wfx.AvgBytesPerSec, wfx.BlockAlign,
				wfx.BitsPerSample, 'data', datasize);
			self.request.sendall('200:OK Wave data follows:%d\n' % (datasize+len(hdr)))
			self.request.sendall(hdr)
			
		self.request.sendall(data)
		self.request.sendall('\n201:Synth OK:\n')
		pythoncom.CoUninitialize()

	def handle(self):
		settings={'volume':100,'rate':0}
		self.f=self.request.makefile('r+')
		while True:
			cmd=self.f.readline()
			if cmd == '':
				break
			cmd=cmd.strip().split(None,1)
			if len(cmd) == 0:
				return
			if len(cmd) > 0:
				command=cmd[0].lower()
				if command in ('getengine','voices'):
					self.voices()
					continue
				if command == 'killserver':
					self.request.sendall('299:Shutdown OK:\n')
					self.server.shutdown()
					return
				if command in ('closeclient','quit'):
					self.request.sendall('299:Quit OK:\n')
					return
				if command == 'speak':
					lines=[]
					while True:
						line=self.f.readline()
						if line == '':
							break
						if line.strip() == '.':
							break
						if line.strip() == '..':
							line=line[1:]
						lines.append(line)
					self.speak(''.join(lines),settings)
					return
				if len(cmd) > 1:
					if command == 'setvoice':
						v=self.prepareVoiceByName(cmd[1])
						if v is not None:
							settings['voice']=v
						continue
					if command == 'setengine':
						v=self.prepareVoice(cmd[1])
						if v is not None:
							settings['voice']=v
						continue
					if command == 'setpitch':
						self.request.sendall('202:Setting OK:setPitch\n')
						continue
					if command == 'setvol':
						vol=self.ensure(cmd[1],0,100)
						settings['volume']=vol
						#self.server.speaker.Volume=vol
						self.request.sendall('202:settingOK:setVolume\n')
						continue
					if command == 'setrate':
						rate=self.ensure(cmd[1],-10,10)
						settings['rate']=rate
						self.server.speaker.Rate=rate
						self.request.sendall('202:settingOK:setRate\n')
						continue
					if command == 'speakme':
						data = cmd[1]
						self.speak(data,settings)
						return
			self.request.sendall("500 What?\n");

		return



class SapiServer(SocketServer.ThreadingTCPServer):
	def __init__(self,*args,**kwargs):
		SocketServer.ThreadingTCPServer.__init__(self,*args,**kwargs)
		self.speaker = win32com.client.Dispatch("SAPI.SpVoice")
		self.voices=self.speaker.GetVoices()

def help(ecode=1):
	global _VERSION
	sys.stdout.write("""Sapi4Linux server v. %s
Usage: %s [options]
  -p, --port=number	 - port number (default 8765)
  -t, --timeout=seconds - maximun server running time (0 = forever)
  -h, --help			- this help
""" % (_VERSION,sys.argv[0]))
	sys.exit(ecode)

def server_thread():
	global server
	try:
		server.serve_forever()
	except:
		pass
	print "Good bye"
	return


def main():

	port=8765
	timeout=0
	filemode=False

	try:
		opts,args=getopt.getopt(sys.argv[1:],"p:t:hf",["port=","timeout=","help","filemode"])
	except getopt.GetoptError as err:
		print str(err)
		help()

	
	for o,a in opts:
		if o in ('-h','--help'):
			help(0)
		if o in ('-p','--port'):
			port=int(a)
			continue
		if o in ('-t','--timeout'):
			timeout=int(a)
		if o in ('-f','--filemode'):
			filemode=True
		else:
			assert False, "Unhandled option"
	
	server=SapiServer(('',port),SapiHandler)
	server.mutex=threading.Lock()
	server.filemode=filemode
	if filemode:
		#server.tempFile=os.path.join(tempfile.gettempdir(),'pyssapi.wav')
		# there is probably bug in Wine, so let's try:
		tempDir="c:\\temp"
		try:
			os.makedirs(tempDir,0777)
		except:
			pass
		server.tempFile=os.path.join(tempDir,'pyssapi.wav')
		
	print "Server started listening on port %d with timeout %d" % (port,timeout)
	
	if timeout <= 0:
		try:
			server.serve_forever()
		except KeyboardInterrupt:
			print "Good bye"
			server.shutdown()
	else:	
		t=threading.Thread(target=server_thread)
		t.start()
		import time
		try:
			time.sleep(timeout)
		except:
			pass
		server.shutdown()

if __name__ == '__main__':
	main()
	
